//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Authorization
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Set Authorization Provider command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SetAuthorizationProviderRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _authorizationProvider;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public SetAuthorizationProviderRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="authorizationProvider">The UUID of the SiLA server that this server uses to verify access tokens.</param>
        public SetAuthorizationProviderRequestDto(string authorizationProvider, Tecan.Sila2.IBinaryStore store)
        {
            AuthorizationProvider = new Tecan.Sila2.StringDto(authorizationProvider, store);
        }
        
        /// <summary>
        /// The UUID of the SiLA server that this server uses to verify access tokens.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto AuthorizationProvider
        {
            get
            {
                return _authorizationProvider;
            }
            set
            {
                _authorizationProvider = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/AuthorizationConfigurationService/v1/Command/SetAuthorizati" +
                    "onProvider";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(AuthorizationProvider, "authorizationProvider");
            if ((AuthorizationProvider.Value.Length != 36))
            {
                throw new ArgumentException(string.Format("AuthorizationProvider has length {0} but should have been 36", AuthorizationProvider.Value.Length), "authorizationProvider");
            }
            if ((RegexConstraint.IsMatch(AuthorizationProvider.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                throw new ArgumentException(string.Format("AuthorizationProvider \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-" +
                            "9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", AuthorizationProvider.Value), "authorizationProvider");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(AuthorizationProvider, "authorizationProvider"));
            if ((AuthorizationProvider.Value.Length != 36))
            {
                errors = (errors + string.Format("AuthorizationProvider has length {0} but should have been 36", AuthorizationProvider.Value.Length));
            }
            if ((RegexConstraint.IsMatch(AuthorizationProvider.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("AuthorizationProvider \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-" +
                        "9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", AuthorizationProvider.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object to encapsulate the response of the Authorization Provider property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class AuthorizationProviderResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public AuthorizationProviderResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public AuthorizationProviderResponseDto(string value, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.StringDto(value, store);
        }
        
        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            if ((Value.Value.Length != 36))
            {
                throw new ArgumentException(string.Format("Value has length {0} but should have been 36", Value.Value.Length), "value");
            }
            if ((RegexConstraint.IsMatch(Value.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                throw new ArgumentException(string.Format("Value \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-" +
                            "f]{4}\\-[0-9a-f]{12}\'", Value.Value), "value");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Value, "value"));
            if ((Value.Value.Length != 36))
            {
                errors = (errors + string.Format("Value has length {0} but should have been 36", Value.Value.Length));
            }
            if ((RegexConstraint.IsMatch(Value.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("Value \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-" +
                        "f]{4}\\-[0-9a-f]{12}\'", Value.Value));
            }
            return errors;
        }
    }
}
